<script setup lang="ts">
    import { isUndefined } from '@/shared/helpers/types'
    import { computed } from 'vue'
    import { useDisplay } from 'vuetify/lib/framework.mjs'

    const { lgAndUp } = useDisplay()

    interface Props {
        icon?: string
        label?: string
        display?:
            | 'inline'
            | 'floating-absolute'
            | 'floating-fixed'
            | 'sticky-bottom'
        position?: 'left' | 'right'
    }

    const props = withDefaults(defineProps<Props>(), {
        icon: undefined,
        label: undefined,
        display: 'inline',
        position: 'right',
    })

    const fabSize = computed(() => {
        return lgAndUp.value ? 'x-large' : 'large'
    })

    const fabPosition = computed(() => {
        if (['floating-fixed', 'floating-absolute'].includes(props.display)) {
            return {
                left: props.position === 'left' ? '25px' : 'initial',
                right: props.position === 'right' ? '25px' : 'initial',
            }
        }
        return {}
    })
</script>

<template>
    <div
        v-if="display === 'sticky-bottom'"
        class="w-100 position-sticky d-flex"
        style="bottom: 25px"
        :style="fabPosition"
        :class="{
            'justify-end': position === 'right',
            'justify-center': isUndefined(position),
        }"
    >
        <v-btn
            class="action-button sticky-bottom mx-5"
            :prepend-icon="icon"
            :size="fabSize"
        >
            <slot>{{ label }}</slot>
        </v-btn>
    </div>
    <v-btn
        v-else
        class="action-button mx-auto"
        :class="{
            'floating-fixed': display === 'floating-fixed',
            'floating-absolute': display === 'floating-absolute',
        }"
        :prepend-icon="icon"
        :size="fabSize"
        :style="fabPosition"
    >
        <slot>{{ label }}</slot>
    </v-btn>
</template>

<style scoped lang="scss">
    .action-button {
        &.floating-fixed {
            position: fixed;
            right: 25px;
            bottom: 25px;
            z-index: 1001;
        }
        &.floating-absolute {
            position: absolute;
            right: 25px;
            bottom: 25px;
            z-index: 1001;
        }
    }
</style>
